unit util;

interface

uses param{, windows}, sysutils;

var{ GHandleOut:Cardinal;}
//    f:textfile;
    StartTime,CurrTime:TDateTime;

function CheckReps(ply:byte):boolean;
procedure ShowBoard;
function substr(var str:string;ch:char):string;
{procedure getstd;}
procedure lprint(msgs:string);
function input:string;
procedure newrule;
procedure copytree(f_ply,t_ply:integer);
procedure StartTimer;
function GetTimer:longint;
procedure init;

implementation

procedure init;
var i,j:integer;
    x1,y1,x2,y2:integer;
    res:real;
begin
  for i:=0 to 127 do
    if (i and 136)=0 then
    begin
      x1:=i and 7; y1:=i shr 4;
      vert[i]:=x1;
      hor[i]:=y1;
      for j:=0 to 127 do
        if (j and 136)=0 then
        begin
          x2:=j and 7; y2:=j shr 4;
          res:=sqrt(sqr(x1-x2)+sqr(y1-y2));
          rasst[i,j]:=trunc(res);
        end;
    end;
end;

function CheckReps(ply:byte):boolean;
var i,pos:integer;
begin
  pos:=0;
  i:=ply-1;
  while i>0 do
  begin
    if tree[i].boardkey=tree[ply].boardkey then inc(pos);
    if pos=2 then
    begin
      result:=true;
      exit;
    end;
    dec(i);
  end;
  i:=rule50;
  while i>0 do
  begin
    if ProvHash[i]=tree[ply].boardkey then inc(pos);
    if pos=2 then
    begin
      result:=true;
      exit;
    end;
    dec(i);
  end;
  result:=false;
end;

procedure StartTimer;
begin
  StartTime:=now;
end;

function GetTimer:longint;
begin
  CurrTime:=now;
  Result:=trunc((CurrTime-StartTime)*86400000);
end;

procedure copytree(f_ply,t_ply:integer);
begin
  tree[t_ply].tomove:=tree[f_ply].tomove;
  tree[t_ply].castles:=tree[f_ply].castles;
  tree[t_ply].enpass:=tree[f_ply].enpass;
  tree[t_ply].boardkey:=tree[f_ply].boardkey;
  tree[t_ply].pawnkey:=tree[f_ply].pawnkey;
  tree[t_ply].matw:=tree[f_ply].matw;
  tree[t_ply].matb:=tree[f_ply].matb;
  tree[t_ply].wking:=tree[f_ply].wking;
  tree[t_ply].wqueen:=tree[f_ply].wqueen;
  tree[t_ply].bking:=tree[f_ply].bking;
  tree[t_ply].bqueen:=tree[f_ply].bqueen;
  tree[t_ply].lastmove:=tree[f_ply].lastmove;
end;

procedure ShowBoard;
var i,j:integer;
    s:string;
begin
  s:='';
  for i:=119 downto 0 do
    if (i and 136)=0 then
    begin
      if (board[i] and 64)<>0 then j:=0
      else j:=1;
      s:=figs[j,board[i] and 7]+s;
      if length(s)=8 then
      begin
        lprint(s);
        s:='';
      end;
    end;
end;

function substr(var str:string;ch:char):string;
var
  a:integer;
begin
  a:=pos(ch,str);
  if a=0 then
  begin
    result:=str;
    str:='';
  end else
  begin
    result:=copy(str,1,a-1);
    str:=copy(str,a+1,length(str)-a);
  end;
end;
(*
procedure getstd;
begin
  gHandleout:=getstdhandle(std_output_handle);
{  assignfile(f,'iolog.txt');
  rewrite(f);
  writeln(f,ver);
  writeln(f,'Input/Output log');
  closefile(f);}
end;
*)
procedure lprint(msgs:string);
(*
var x1:Pchar;
    len:Cardinal;
begin
{  assignfile(f,'iolog.txt');
  Append(f);
  writeln(f,'--> ',msgs);
  closefile(f);}
  len:=length(msgs);
  x1:=pchar(msgs + #10);
  _lwrite(gHandleout,x1,len+1);
*)
begin
  WriteLn(msgs);
  Flush(output);
end;

function input:string;
var res:string;
begin
  result:='';
  readln(res);
//  if res='' then exit;
{  assignfile(f,'iolog.txt');
  Append(f);
  writeln(f,'<-- ',res);
  closefile(f);}
  result:=res;
end;

procedure newrule;
begin
  rules.depth:=0;
  rules.movetime:=0;
  rules.wtime:=0;
  rules.btime:=0;
  rules.winc:=0;
  rules.binc:=0;
  rules.mate:=0;
  rules.infinite:=false;
  rules.movestogo:=0;
  rules.nodes:=0;
  rules.ponder:=false;
end;

end.
